-- Количество звонков за последние 30 дней
DECLARE @IdConstructorAxis INT
SET @IdConstructorAxis = 5

SELECT interv [Интервал],
              cnt [Всего],
              cnt_connected [Обслужено],
			 (cnt - cnt_connected-cnt_operator_missed)  [Потеряно],
             cnt_operator_missed [Пропущено]
FROM (
SELECT CASE @IdConstructorAxis
                    WHEN 1 THEN convert(nvarchar(5), cast((floor(cast(DateTimeStart as float) * 287.999999999999) / 287.999999999999 - floor(cast(DateTimeStart as float))) as datetime), 108) + ' - ' + 
                                convert(nvarchar(5), dateadd(mi, 5, cast((floor(cast(DateTimeStart as float) * 287.999999999999) / 287.999999999999 - floor(cast(DateTimeStart as float))) as datetime)), 108)
                    WHEN 2 THEN convert(nvarchar(5), cast((floor(cast(DateTimeStart as float) * 95.999999999999) / 95.999999999999 - floor(cast(DateTimeStart as float))) as datetime), 108) + ' - ' + 
                                convert(nvarchar(5), dateadd(mi, 15, cast((floor(cast(DateTimeStart as float) * 95.999999999999) / 95.999999999999 - floor(cast(DateTimeStart as float))) as datetime)), 108)
                    WHEN 3 THEN convert(nvarchar(5), cast((floor(cast(DateTimeStart as float) * 47.999999999999) / 47.999999999999 - floor(cast(DateTimeStart as float))) as datetime), 108) + ' - ' + 
                                convert(nvarchar(5), dateadd(mi, 30, cast((floor(cast(DateTimeStart as float) * 47.999999999999) / 47.999999999999 - floor(cast(DateTimeStart as float))) as datetime)), 108)
                    WHEN 4 THEN convert(nvarchar(5), cast((floor(cast(DateTimeStart as float) * 23.999999999999) / 23.999999999999 - floor(cast(DateTimeStart as float))) as datetime), 108) + ' - ' + 
                                convert(nvarchar(5), dateadd(hh, 1, cast((floor(cast(DateTimeStart as float) * 23.999999999999) / 23.999999999999 - floor(cast(DateTimeStart as float))) as datetime)), 108)
                    WHEN 5 THEN cast(datepart(yy, cast(floor(cast(DateTimeStart as float)) as datetime)) as nvarchar(4)) + '-' + 
                                convert(nvarchar(5), cast(floor(cast(DateTimeStart as float)) as datetime), 10)
                    WHEN 6 THEN cast(datepart(yy, cast(floor(cast(DateTimeStart as float)) as datetime)) as nvarchar(4)) + '-' + 
                                convert(nvarchar(5), cast(floor(cast(DateTimeStart as float) - datepart(dw, DateTimeStart) + 1) as datetime), 10) + ' - ' + 
                                cast(datepart(yy, cast(floor(cast(DateTimeStart as float)) as datetime)) as nvarchar(4)) + '-' + 
                                convert(nvarchar(5), dateadd(dd, 7, cast(floor(cast(DateTimeStart as float) - datepart(dw, DateTimeStart) + 1) as datetime)), 10)
                    WHEN 7 THEN case datepart(mm, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + '-' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + '-01' as datetime))
                                     when 1 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + '-' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + '-01' as datetime)) as nvarchar(4)) + '-01'
                                     when 2 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + '-' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + '-01' as datetime)) as nvarchar(4)) + '-02'
                                     when 3 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + '-' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + '-01' as datetime)) as nvarchar(4)) + '-03'
                                     when 4 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + '-' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + '-01' as datetime)) as nvarchar(4)) + '-04'
                                     when 5 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + '-' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + '-01' as datetime)) as nvarchar(4)) + '-05'
                                     when 6 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + '-' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + '-01' as datetime)) as nvarchar(4)) + '-06'
                                     when 7 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + '-' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + '-01' as datetime)) as nvarchar(4)) + '-07'
                                     when 8 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + '-' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + '-01' as datetime)) as nvarchar(4)) + '-08'
                                     when 9 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + '-' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + '-01' as datetime)) as nvarchar(4)) + '-09'
                                     when 10 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + '-' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + '-01' as datetime)) as nvarchar(4)) + '-10'
                                     when 11 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + '-' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + '-01' as datetime)) as nvarchar(4)) + '-11'
                                     when 12 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + '-' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + '-01' as datetime)) as nvarchar(4)) + '-12'
                                end
                    WHEN 8 THEN cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar (4)) + '-01-01' as datetime)) as nvarchar(4))
                    ELSE NULL
            END [interv],
            COUNT(tt.IdCHAIN) cnt,
            SUM(have_res) + SUM(CASE WHEN have_operator = 1 AND cr1 = 1 AND missed = 0 AND block_b = 0 AND have_res = 0 AND operator_missed = 0 AND not_between_work_time =0 THEN 1 ELSE 0 END) cnt_connected,
            SUM(CASE WHEN have_res = 0 AND 
						  have_operator = 1 AND 
						  cr1 = 0 AND 
						  missed = 0 AND 
						  block_b = 0 AND 
						  operator_missed = 0 AND 
						  not_between_work_time=0
					 THEN 1 ELSE 0 END) + SUM(CASE WHEN have_res = 1 THEN 0 ELSE operator_missed END) cnt_operator_missed
FROM (
SELECT IdCHAIN,
           CASE WHEN SUM(CASE WHEN CallResult IN (5,18) AND IdOperator != 'ab000000-0000-0000-0000-000000000000' THEN 1 
							  ELSE 0 END) > 0 THEN 1 ELSE 0 END have_res,
           MIN(DateTimeStart) DateTimeStart,
           MAX(DateTimeStart) MAX_DateTimeStart,
           CASE WHEN SUM(CASE WHEN LEFT(BLineNum,2) NOT IN ('11','12','13','14') AND COALESCE(IdBUser,'ab000000-0000-0000-0000-000000000000') NOT IN ( 'ab000000-0000-0000-0000-000000000000','bf000000-0000-0000-0000-000000000000') AND  LenTime > 0 THEN 1 ELSE 0 END ) > 1 THEN 1 ELSE 0 END passed_in,
           CASE WHEN SUM(CASE WHEN LEFT(BLineNum,2) IN ('11','12','13','14') AND LenTime > 0 THEN 1 ELSE 0 END ) > 0 THEN 1 ELSE 0 END passed_out,
           CASE WHEN SUM(CASE WHEN COALESCE(IdOperator,'ab000000-0000-0000-0000-000000000000') != 'ab000000-0000-0000-0000-000000000000' THEN 1 ELSE 0 END ) > 0 THEN 1 ELSE 0 END have_operator,
           CASE WHEN SUM(CASE WHEN CallResult IN (13) THEN 1 ELSE 0 END) > 0 THEN 1 ELSE 0 END missed,
           CASE WHEN SUM(CASE WHEN CallResult IN (21,22,25,26,27) THEN 1 ELSE 0 END) > 0 THEN 1 ELSE 0 END block_b,
           CASE WHEN SUM(CASE WHEN CallResult IN (23) THEN 1 ELSE 0 END) > 0 THEN 1 ELSE 0 END not_between_work_time,
           CASE WHEN SUM(CASE WHEN CallResult IN (7) THEN 1 ELSE 0 END) > 0 THEN 1 ELSE 0 END operator_missed,
 		   CASE WHEN SUM(CASE WHEN CallResult = 1 THEN 1 ELSE 0 END)  > 0 THEN 1 ELSE 0 END cr1,
           MAX(LenQueue) p_LenQueue
    FROM  oktell_cc_temp..A_Cube_CC_EffortConnections c
    WHERE DateStart >= dateadd(dd,-30,cast(getdate() as DATE))
        AND IdCHAIN IS NOT NULL
        AND COALESCE(IsOutput,0) = 0
        GROUP BY IdCHAIN
) tt
 GROUP BY CASE @IdConstructorAxis
                    WHEN 1 THEN convert(nvarchar(5), cast((floor(cast(DateTimeStart as float) * 287.999999999999) / 287.999999999999 - floor(cast(DateTimeStart as float))) as datetime), 108) + ' - ' + 
                                convert(nvarchar(5), dateadd(mi, 5, cast((floor(cast(DateTimeStart as float) * 287.999999999999) / 287.999999999999 - floor(cast(DateTimeStart as float))) as datetime)), 108)
                    WHEN 2 THEN convert(nvarchar(5), cast((floor(cast(DateTimeStart as float) * 95.999999999999) / 95.999999999999 - floor(cast(DateTimeStart as float))) as datetime), 108) + ' - ' + 
                                convert(nvarchar(5), dateadd(mi, 15, cast((floor(cast(DateTimeStart as float) * 95.999999999999) / 95.999999999999 - floor(cast(DateTimeStart as float))) as datetime)), 108)
                    WHEN 3 THEN convert(nvarchar(5), cast((floor(cast(DateTimeStart as float) * 47.999999999999) / 47.999999999999 - floor(cast(DateTimeStart as float))) as datetime), 108) + ' - ' + 
                                convert(nvarchar(5), dateadd(mi, 30, cast((floor(cast(DateTimeStart as float) * 47.999999999999) / 47.999999999999 - floor(cast(DateTimeStart as float))) as datetime)), 108)
                    WHEN 4 THEN convert(nvarchar(5), cast((floor(cast(DateTimeStart as float) * 23.999999999999) / 23.999999999999 - floor(cast(DateTimeStart as float))) as datetime), 108) + ' - ' + 
                                convert(nvarchar(5), dateadd(hh, 1, cast((floor(cast(DateTimeStart as float) * 23.999999999999) / 23.999999999999 - floor(cast(DateTimeStart as float))) as datetime)), 108)
                    WHEN 5 THEN cast(datepart(yy, cast(floor(cast(DateTimeStart as float)) as datetime)) as nvarchar(4)) + '-' + 
                                convert(nvarchar(5), cast(floor(cast(DateTimeStart as float)) as datetime), 10)
                    WHEN 6 THEN cast(datepart(yy, cast(floor(cast(DateTimeStart as float)) as datetime)) as nvarchar(4)) + '-' + 
                                convert(nvarchar(5), cast(floor(cast(DateTimeStart as float) - datepart(dw, DateTimeStart) + 1) as datetime), 10) + ' - ' + 
                                cast(datepart(yy, cast(floor(cast(DateTimeStart as float)) as datetime)) as nvarchar(4)) + '-' + 
                                convert(nvarchar(5), dateadd(dd, 7, cast(floor(cast(DateTimeStart as float) - datepart(dw, DateTimeStart) + 1) as datetime)), 10)
                    WHEN 7 THEN case datepart(mm, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + '-' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + '-01' as datetime))
                                     when 1 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + '-' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + '-01' as datetime)) as nvarchar(4)) + '-01'
                                     when 2 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + '-' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + '-01' as datetime)) as nvarchar(4)) + '-02'
                                     when 3 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + '-' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + '-01' as datetime)) as nvarchar(4)) + '-03'
                                     when 4 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + '-' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + '-01' as datetime)) as nvarchar(4)) + '-04'
                                     when 5 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + '-' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + '-01' as datetime)) as nvarchar(4)) + '-05'
                                     when 6 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + '-' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + '-01' as datetime)) as nvarchar(4)) + '-06'
                                     when 7 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + '-' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + '-01' as datetime)) as nvarchar(4)) + '-07'
                                     when 8 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + '-' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + '-01' as datetime)) as nvarchar(4)) + '-08'
                                     when 9 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + '-' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + '-01' as datetime)) as nvarchar(4)) + '-09'
                                     when 10 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + '-' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + '-01' as datetime)) as nvarchar(4)) + '-10'
                                     when 11 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + '-' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + '-01' as datetime)) as nvarchar(4)) + '-11'
                                     when 12 then cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar(4)) + '-' + cast(datepart(mm, DateTimeStart) as nvarchar(2)) + '-01' as datetime)) as nvarchar(4)) + '-12'
                                end
                    WHEN 8 THEN cast(datepart(yy, cast(cast(datepart(yy, DateTimeStart) as nvarchar (4)) + '-01-01' as datetime)) as nvarchar(4))
                    ELSE NULL
            END
)     t
order by 1 DESC